﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using CampusUOC.Clases;
using CampusUOC.Recursos;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace CampusUOC
{
    public partial class Board : PhoneApplicationPage
    {
        private Messages _mensajes;
        private int _indice;
        private static int _NumMensajes = 10;
        private Clases.Board _board;
        private string _idBoard, _idSubject;

        public Board()
        {
            InitializeComponent();
        }

        private void Inicializar()
        {
            InicializarIdioma();
            CargarBoard();
            CargarMensajes();
            lblBoard.Text = AppResources.Board;
        }

        public void InicializarIdioma()
        {
            lblApplication.Text = AppResources.ApplicationTitle;
            lblBoard.Text = AppResources.Loading + " " + AppResources.Inbox;
        }
        
        private async void CargarBoard()
        {
            try
            {
                Clases.Boards boards = await Procedimientos.GetBoards(Convert.ToInt32(_idSubject));
                foreach (var board in boards.boards)
                {
                    if (board.id == _idBoard) this._board = board;
                }
            }
            catch (Exception exc)
            {
                MessageBox.Show("Error loading inbox: " + exc);
            }

        }
        
        private async void CargarMensajes()
        {
            try
            {
                lbMensajes.ItemsSource = (await Procedimientos.GetBoardMessages(_idSubject,_idBoard, _indice, _indice + _NumMensajes)).messages;
                ActualizaPaginacion();
            }
            catch (Exception exc)
            {
                MessageBox.Show("Error loading inbox messages: " + exc);
            }

        }

        private void btnNext_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            _indice += _NumMensajes;
            if (_indice > _board.totalMessages) _indice = (int)_board.totalMessages - 1;
            CargarMensajes();
        }

        private void btnBack_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            _indice -= _NumMensajes;
            if (_indice < 0) _indice = 0;
            CargarMensajes();
        }

        private void ActualizaPaginacion()
        {
            if (_board != null)
            {
                long total = (_board.totalMessages / _NumMensajes) + 1;
                long actual = (_indice % _NumMensajes) + 1;
                tbPaginacion.Text = total + "/" + actual;
            }
            else tbPaginacion.Text = string.Empty;
        }

        private void StackPanel_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {

        }

        private void Button_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            MessageMapping m = (MessageMapping)((Button)sender).DataContext;

            NavigationService.Navigate(new Uri("/Message.xaml?idMessage=" + m.id + "&tipoMensaje=Board&idSubject=" + _idSubject+ "&idBoard="+_idBoard, UriKind.Relative));
            
        }

        private void PhoneApplicationPage_Loaded_1(object sender, RoutedEventArgs e)
        {
            
            if (this.NavigationContext.QueryString.ContainsKey("idBoard"))
            {
                _idBoard = NavigationContext.QueryString["idBoard"];
                _idSubject = NavigationContext.QueryString["idSubject"];
            }

            Inicializar();
        }

    }
}