﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using WPControls;

namespace CampusUOC.Clases
{
    public class ColorConverter : IDateToBrushConverter
    {
        public IEnumerable<DateTime> Dates { get; set; }

        public Brush Convert(DateTime dateTime, bool isSelected, Brush defaultValue, BrushType brushType)
        {
            if (brushType == BrushType.Background)
            {
                if (isSelected)
                {
                    return new SolidColorBrush(Colors.Green);
                }

                if (Dates != null && Dates.Any(d => d.Date == dateTime))
                {
                    return new SolidColorBrush(Color.FromArgb(129, 255, 255, 0));
                }

                return defaultValue;
            }

            //if (dateTime == new DateTime(DateTime.Today.Year, DateTime.Today.Month, 6))
            if (Dates != null && Dates.Any(d => d.Date == dateTime))
            {
                return new SolidColorBrush(Colors.Red);
            }
            return defaultValue;

        }
    }
}
