﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using CampusUOC.Clases;
using CampusUOC.Recursos;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Newtonsoft.Json;

namespace CampusUOC
{
    public partial class Compose : PhoneApplicationPage
    {

        private User _actualUser;

        public Compose()
        {
            InitializeComponent();

            InicializarIdioma();

            CargarUsuario();
        }

        private void InicializarIdioma()
        {
            lblApplication.Text = AppResources.ApplicationTitle;
            lblTitle.Text = AppResources.Message;
            this.lblSubject.Text = AppResources.Subject;
            this.lblTo.Text = AppResources.To;
            this.lblContent.Text = AppResources.Body;
            this.txtContent.Text = string.Empty;
            this.txtSubject.Text = string.Empty;
            this.txtTo.Text = string.Empty;
            this.txtContent.Text = string.Empty;
            btnEnviar.Content = AppResources.Send;


            /*
            txtTo.Text = "pleonma@uoc.edu";
            txtSubject.Text = "Asunto de prueba " + DateTime.Now.Ticks;
            txtContent.Text = "Cuerpo de mensaje de prueba " + DateTime.Now.Ticks;
             * */
        }

        private async void  CargarUsuario()
        {
            this._actualUser = await Procedimientos.GetUser();
        }

        private void btnEnviar_Click(object sender, RoutedEventArgs e)
        {
            /*
            foreach (var mail in txtTo.Text.Split(';'))
            {
                if (!IsValidEmail(mail.Trim()))
                {
                    MessageBox.Show(AppResources.InvalidEmail + " (" + mail + ")");
                    return;
                }
            }
            */

                if (!IsValidEmail(txtTo.Text.Trim()))
                {
                    MessageBox.Show(AppResources.InvalidEmail + " (" + txtTo.Text + ")");
                    return;
                }


            if (txtSubject.Text.Trim().Length == 0 && txtContent.Text.Trim().Length == 0)
            {
                MessageBox.Show(AppResources.BodySubjectEmpty);
                return;
            }

            CargaMensaje();

            
        }

        private async void CargaMensaje()
        {
            //MessageMapping resul = await Procedimientos.SendMessage(txtTo.Text, txtSubject.Text, txtContent.Text);
            
            MessageMapping msg = new MessageMapping();
            msg.body = txtContent.Text;
            msg.subject = txtSubject.Text;
            msg.to = txtTo.Text;
            msg.from = _actualUser.email;
            string json = JsonConvert.SerializeObject( msg );
            bool ok = await Procedimientos.Post(Config.MAILMESSAGES_URI, LicenciaActual.Licencia.access_token, json);
            
            if(ok)
                MessageBox.Show(AppResources.MessageSent);
            else
                MessageBox.Show(AppResources.ErrorSendingMessage);
        }

        private bool IsValidEmail(string strIn)
        {
            return Regex.IsMatch(strIn,
              @"^(?("")(""[^""]+?""@)|(([0-9a-zA-Z]((\.(?!\.))|[-!#\$%&'\*\+/=\?\^`\{\}\|~\w])*)(?<=[0-9a-zA-Z])@))" +
              @"(?(\[)(\[(\d{1,3}\.){3}\d{1,3}\])|(([0-9a-zA-Z][-\w]*[0-9a-zA-Z]\.)+[a-zA-Z]{2,3}))$");
        }
    }
}