﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using CampusUOC.Clases;
using CampusUOC.Recursos;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace CampusUOC
{
    public partial class Inbox : PhoneApplicationPage
    {
        private Messages _mensajes;
        private int _indice;
        private static int _NumMensajes = 10;
        private InboxMapping _bandejaDeEntrada;

        public Inbox()
        {
            InitializeComponent();
            
        }

        private void Inicializar()
        {
            InicializarIdioma();
            CargarBandejaDeEntrada();
            CargarMensajes();
            lblInbox.Text = AppResources.Inbox;
        }

        public void InicializarIdioma()
        {
            lblApplication.Text = AppResources.ApplicationTitle;
            lblInbox.Text = AppResources.Loading + " " + AppResources.Inbox;
        }

        private async void CargarBandejaDeEntrada()
        {
            try
            {
                this._bandejaDeEntrada = await Procedimientos.GetInbox();
            }
            catch (Exception exc)
            {
                MessageBox.Show("Error loading inbox: " + exc);
            }

        }

        private async void CargarMensajes()
        {
            try
            {
                lbMensajes.ItemsSource = (await Procedimientos.GetInbox(_indice, _indice + _NumMensajes)).messages;
                ActualizaPaginacion();
            }
            catch (Exception exc)
            {
                MessageBox.Show("Error loading inbox messages: " + exc);
            }

        }

        private void btnNext_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            _indice += _NumMensajes;
            if (_indice > _bandejaDeEntrada.totalMessages) _indice = (int) _bandejaDeEntrada.totalMessages - 1;
            CargarMensajes();
        }

        private void btnBack_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            _indice -= _NumMensajes;
            if (_indice < 0) _indice = 0;
            CargarMensajes();
        }

        private void ActualizaPaginacion()
        {
            if (_bandejaDeEntrada != null)
            {
                long total = (_bandejaDeEntrada.totalMessages/_NumMensajes) + 1;
                long actual = (_indice%_NumMensajes) + 1;
                tbPaginacion.Text = total + "/" + actual;
            }
            else tbPaginacion.Text = string.Empty;
        }

        private void StackPanel_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            
        }

        private void Button_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            MessageMapping m = (MessageMapping) ((Button) sender).DataContext;

            NavigationService.Navigate(new Uri("/Message.xaml?idMessage="+m.id, UriKind.Relative));


        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            /*
            if (this.NavigationContext.QueryString.ContainsKey("idBoard"))
            {
                _idBoard = NavigationContext.QueryString["idSubject"];
            }*/

            Inicializar();
        }
    }
}