﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO.IsolatedStorage;
using System.Linq;
using System.Net;
using System.Net.NetworkInformation;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using CampusUOC.Clases;
using Microsoft.Phone.Controls;
using System.Windows.Markup;
using System.Globalization;
using RestSharp;
using CampusUOC.Recursos;

namespace CampusUOC
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Licencia licencia
        {
            set
            {
                LicenciaActual.Licencia = value;
                if(value.access_token != null && !value.access_token.Equals(string.Empty))
                    PasarAPaginaPrincipal();
            }

            get
            {
                return LicenciaActual.Licencia;
            }
        }

        string _code;

        string Code
        {
            get { return _code; }
            set
            {
                _code = value;
                Debug.WriteLine(value);

                //webBrowser1.Navigate(new Uri(TOKEN_URI + "?scope=" + HttpUtility.UrlEncode("READ+READ_BOARD+READ_MAIL+SEND_BOARD+SEND_MAIL+WRITE") + "&redirect_uri=" + HttpUtility.UrlEncode("www.uoc.cat") + "&code=" +  HttpUtility.UrlEncode(value)));
                if(value != null && !value.Equals(string.Empty))
                    ConsultaPideAutorizacion(value);
            }
        }

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            Procedimientos.CargarIdioma();
            InicializarIdioma();

            if(TenemosInternet())
                ConsultaRestVisualiza();
            else
                lblDebeAutenticarse.Text = AppResources.NoInternet;
        }

        private void InicializarIdioma()
        {
            lblDebeAutenticarse.Text = AppResources.YouMustAuthenticate;
            PageTitle.Text = AppResources.Login;
            ApplicationTitle.Text = AppResources.ApplicationTitle;
            btnRefrescar.Content = AppResources.Refresh;
        }

        private bool TenemosInternet()
        {
            bool tenemos = NetworkInterface.GetIsNetworkAvailable();
            lblDebeAutenticarse.Text = tenemos ? lblDebeAutenticarse.Text : AppResources.NoInternet;
            return tenemos;
        }

        private void ConsultaRestVisualiza()
        {
            string authorizeUrl = Config.AUTHORIZE_URI + "?client_id=" + Config.ConsumerKey + "&response_type=code&redirect_uri=" + HttpUtility.UrlEncode("http://www.uoc.cat");

            var cliente = new RestClient(authorizeUrl);
            var request = new RestRequest();

            cliente.ExecuteAsync(request, response =>
            {
                Dispatcher.BeginInvoke(() =>
                {
                    webBrowser1.Navigate(new Uri(authorizeUrl));
                });

                Debug.WriteLine(response == null ? "Response null" : ("Contenido: " + response.Content));
            });
        }

        private void webBrowser1_Navigating(object sender, NavigatingEventArgs e)
        {
            try
            {
                Debug.WriteLine(e.Uri.AbsoluteUri);
                Debug.WriteLine("Navigating: " + e.Uri.AbsoluteUri);
                if (e.Uri != null && e.Uri.AbsoluteUri.Contains("?code=") && _code == null)
                {
                    Code = e.Uri.AbsoluteUri.Substring(e.Uri.AbsoluteUri.IndexOf("?code=") + "?code=".Length);
                }
            }
            catch (Exception ee)
            {
                MessageBox.Show(ee.InnerException == null ? ee.Message : ee.InnerException.Message);
            }
        }

        //delegate void MethodDelegate(RestClient cliente, RestRequest peticio, Action<string> callback);

        private void ConsultaPideAutorizacion(string codigo)
        {

            var cliente = new RestClient(Config.BASEURI);
            var peticio = new RestRequest(Config.TOKEN_URI, Method.POST);
            peticio.AddParameter("scope", "READ+READ_BOARD+READ_MAIL+SEND_BOARD+SEND_MAIL+WRITE");
            //peticio.AddParameter("redirect_uri", v2REDIRECT_URI);
            peticio.AddParameter("redirect_uri", "http://www.uoc.cat");
            peticio.AddParameter("code", codigo);
            peticio.AddParameter("grant_type", "authorization_code");
            peticio.AddParameter("client_id", Config.ConsumerKey);
            peticio.AddParameter("client_secret", Config.ConsumerSecret);

            string iExecThread = string.Empty;

            //MethodDelegate dlgt = new MethodDelegate(Procedimientos.LlamadaAsincronica);
            //{"access_token":"b43ca9e7-9f06-4d9f-8d97-e6a648b65f13","token_type":"bearer","refresh_token":"58d0f665-9859-40af-9bc9-1a43d6986543","expires_in":41997,"scope":"READ READ_BOARD READ_MAIL SEND_BOARD SEND_MAIL WRITE"}
            Procedimientos.LlamadaAsincronica(cliente, peticio, SeteaLicencia) ;

           
        }

        private void SeteaLicencia(string obj)
        {
            Debug.WriteLine(obj);
            if (!string.IsNullOrEmpty(obj))
                this.licencia = (Licencia)Newtonsoft.Json.JsonConvert.DeserializeObject(obj, (new Licencia()).GetType());
            else MessageBox.Show(AppResources.NoAnswerForAuthenticate);

        }


        public void PasarAPaginaPrincipal()
        {
            this.NavigationService.Navigate(new Uri("/MenuPrincipal.xaml", UriKind.Relative));
        }

        private void btnRefrescar_Click(object sender, RoutedEventArgs e)
        {
            _code = null;
            ConsultaRestVisualiza();
        }


    }
}