﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using CampusUOC.Clases;
using CampusUOC.Recursos;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace CampusUOC
{
    public partial class Message : PhoneApplicationPage
    {
        private string _id;
        private MessageMapping _message;
        private string _tipoMensaje, _idBoard, _idSubject;

        public MessageMapping CurrentMessage
        {
            get
            {
                return this._message;
            }

            set
            {
                this._message = value;

                this.txtContent.Text = _message.body;
                this.txtFrom.Text = _message.from;
                this.txtSubject.Text = _message.subject;
                this.txtTo.Text = _message.to;
            }
        }
            
        public Message()
        {
            InitializeComponent();

            InicializarIdioma();
        }

        private void InicializarIdioma()
        {
            this.lblFrom.Text = AppResources.From;
            lblMyApp.Text = AppResources.ApplicationTitle;
            lblTitle.Text = AppResources.Message;
            this.lblSubject.Text = AppResources.Subject;
            this.lblTo.Text = AppResources.To;
            this.txtContent.Text = string.Empty;
            this.txtFrom.Text = string.Empty;
            this.txtSubject.Text = string.Empty;
            this.txtTo.Text = string.Empty;
            this.txtContent.Text = string.Empty;
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (this.NavigationContext.QueryString.ContainsKey("idMessage"))
            {
                _id = NavigationContext.QueryString["idMessage"];
                if (this.NavigationContext.QueryString.ContainsKey("tipoMensaje"))
                {
                    _tipoMensaje = NavigationContext.QueryString["tipoMensaje"];
                    _idBoard = NavigationContext.QueryString["idBoard"];
                    _idSubject = NavigationContext.QueryString["idSubject"];
                }
                CargaMensaje();
            }
        }

        private async void CargaMensaje()
        {
            if (_tipoMensaje == "Board")
                CurrentMessage = await Procedimientos.GetBoardMessage(_idSubject, _idBoard, _id);
            else CurrentMessage = await Procedimientos.GetMessage(_id);
        }

    }
}